LArSoft - Bug #21135

ROOT::Minuit2::VariableMetricBuilder::Minimum Failure
10/13/2018 02:56 PM - Hunter Sullivan

Status: Closed Start date: 10/13/2018
Priority: Normal Due date:

Assignee: Kyle Knoepfel % Done: 100%
Category: Reconstruction Estimated time: 0.00 hour
Target version: Spent time: 20.00 hours
Occurs In: Co-Assignees:

Experiment: LArIAT

Description

lariatsoft/larsoft version: v07_07_01
quals: e17:debug and c2:debug

The LArIAT debug Cl tests are failing.
Here is the failure and the gdb backtrace:

lar: /scratch/workspace/canvas—-products/vdevelop/el7/SLF6/debug/build/root/v6_12_06a/source/root-6
.12.06/math/minuit2/src/VariableMetricBuilder.cxx:267: ROOT: :Minuit2::FunctionMinimum ROOT: :Minuit
2::VariableMetricBuilder: :Minimum(const ROOT: :Minuit2::MnFcné&, const ROOT::Minuit2::GradientCalcul
ator&, const ROOT::Minuit2::MinimumSeed&, std::vector<ROOT::Minuit2::MinimumState>&, unsigned int,
double) const: Assertion "s0.IsValid()' failed.

Program received signal SIGABRT, Aborted.

0x000000367aa324f5 in raise () from /lib64/libc.so.6

Missing separate debuginfos, use: debuginfo-install cyrus-sasl-1ib-2.1.23-13.el16.x86_64 expat-2.0.
1-13.el6_8.x86_64 freetype-2.3.11-15.el16_6.1.x86_64 glibc-2.12-1.212.el16.x86_64 keyutils-libs-1.4-
4.e16.x86_64 krb5-1ibs-1.10.3-42z1.el16_7.x86_64 1ibICE-1.0.6-1.e16.x86_64 1ibSM-1.1.0-7.1.el16.x86_
64 1ibX11-1.6.4-3.e16.x86_64 l1libXau-1.0.6-4.e16.x86_64 libXdamage—-1.1.3-4.e16.x86_64 libXext-1.3.2
-2.1.e16.x86_64 1ibXfixes-5.0.3-1.el16.x86_64 libXmu-1.1.1-2.e16.x86_64 1libXt-1.1.4-6.1.el16.x86_64
libXxf86vm-1.1.3-2.1.el16.x86_64 libcom_err—-1.41.12-12.el16.x86_64 libcurl-7.19.7-53.el6_9.x86_64 11
bdrm-2.4.65-2.e16.x86_64 1libidn-1.18-2.e16.x86_64 libselinux-2.0.94-5.3.e16.x86_64 libssh2-1.4.2-2
.el6_7.1.x86_64 libuuid-2.17.2-12.9.e16.x86_64 libxcb-1.12-4.e16.x86_64 mesa-dri-drivers-11.0.7-4.
el6.x86_64 mesa-1ibGL-11.0.7-4.e16.x86_64 mesa—-1ibGLU-11.0.7-4.el16.x86_64 ncurses—-1libs-5.7-3.20090
208.e16.x86_64 nspr-4.19.0-1.e16.x86_64 nss—-3.36.0-8.el1l6.x86_64 nss—-softokn-freebl-3.14.3-23.el6_7
.xX86_64 nss-util-3.36.0-1.el16.x86_64 openldap-2.4.40-6.e16_7.x86_64 openssl-1.0.1e-48.s16_8.4.x86_
64 pcre-7.8-4.e16.x86_64 xz-1ibs-4.999.9-0.3.beta.20091007git.el6.x86_64 z1lib-1.2.3-29.e16.x86_64
(gdb) backtrace 15

#0 0x000000367aa324f5 in raise () from /lib64/libc.so.6

#1 0x000000367aa33cd5 in abort () from /lib64/libc.so.6

#2 0x000000367aa2bbbe in _ assert_fail base () from /lib64/libc.so.6
#3 0x000000367aa2b730 in _ assert_fail () from /l1lib64/libc.so.6

#4 0x00007fffd2dc84b3 in ROOT::Minuit2::VariableMetricBuilder: :Minimum (ROOT: :Minuit2::MnFcn const
&, ROOT::Minuit2::GradientCalculator consté&, ROOT::Minuit2::MinimumSeed consté&, std::vector<ROOT::
Minuit2::MinimumState, std::allocator<ROOT::Minuit2::MinimumState> >&, unsigned int, double) const
() at /scratch/workspace/canvas-products/vdevelop/el7/SLF6/debug/build/root/v6_12_06a/source/root
-6.12.06/math/minuit2/src/VariableMetricBuilder.cxx:267
#5 0x00007fffd2dc6557 in ROOT: :Minuit?2::VariableMetricBuilder: :Minimum (ROOT: :Minuit2::MnFcn const
&, ROOT::Minuit2::GradientCalculator consté&, ROOT::Minuit2::MinimumSeed consté&, ROOT::Minuit2::MnS
trategy consté&, unsigned int, double) const () at /scratch/workspace/canvas—products/vdevelop/el7/
SLF6/debug/build/root/v6_12_06a/source/root-6.12.06/math/minuit2/src/VariableMetricBuilder.cxx:124
#6 0x00007fffd2dbeeal in ROOT::Minuit2::ModularFunctionMinimizer: :Minimize (ROOT: :Minuit2: :MnFcn c
onst&, ROOT::Minuit2::GradientCalculator consté&, ROOT::Minuit2::MinimumSeed consté&, ROOT::Minuit2:
:MnStrategy consté&, unsigned int, double) const () at /scratch/workspace/canvas-products/vdevelop/
el7/SLF6/debug/build/root/v6_12_06a/source/root-6.12.06/math/minuit2/src/ModularFunctionMinimizer.
cxx:166
#7 0x00007fffd2dbea9e in ROOT: :Minuit2::ModularFunctionMinimizer::Minimize (ROOT: :Minuit2: :FCNBase
consté&, ROOT::Minuit2::MnUserParameterState const&, ROOT::Minuit2::MnStrategy consté&, unsigned in
t, double) const () at /scratch/workspace/canvas-products/vdevelop/el7/SLF6/debug/build/root/v6_12
_06a/source/root—6.12.06/math/minuit2/src/ModularFunctionMinimizer.cxx:120

#8 0x00007fffd2d8ee39 in ROOT::Minuit2::Minuit2Minimizer::Minimize() () at /scratch/workspace/can
vas—-products/vdevelop/el7/SLF6/debug/build/root/v6_12_06a/source/root-6.12.06/math/minuit2/src/Min
uit2Minimizer.cxx:510

#9 0x00007fffe023e414 in trkf::TrackMomentumCalculator: :GetMomentumMultiScatterChi2 (art::Ptr<reco
b::Track> consté&) () at /scratch/workspace/build-larsoft/v07_07_01/SLF6/debug/build/larreco/v07_04
_04/src/larreco/RecoAlg/TrackMomentumCalculator.cxx:827

#10 0x00007fffel5d59fb in lariat::AnaTreeT1034::analyze(art::Event consté&) () at /scratch/workspac
e/lariat-release-build/BUILDTYPE/debug/labell/swarm/label2/SLF6/temp/srcs/lariatsoft/LArIATAnaModu
le/AnaTreeT1034_module.cc:1422

#11 0x00007ffff645f5a2 in art::EDAnalyzer::doEvent () at /scratch/workspace/art-release-build/SLF6
/debug/build/art/v2_11_03/src/art/Framework/Core/EDAnalyzer.cc:29

#12 0x00007fffel647f3b in art::WorkerT<art::EDAnalyzer>::implDoProcess () at /cvmfs/larsoft.opensc
iencegrid.org/products/art/v2_11_03/include/art/Framework/Core/WorkerT.h:88

#13 0x00007f£f£f£72bb575 in bool art::Worker::ImplDoWork<(art::BranchActionType)2>::invoke<art::Even
tPrincipal> (art::Worker*, art::EventPrincipalé&, art::CurrentProcessingContext const*) () at /scrat
ch/workspace/art-release-build/SLF6/debug/build/art/v2_11_03/src/art/Framework/Principal/Worker.h:
201

#14 0x00007f£ff£f72b0d63 in bool art::Worker::doWork<art::ProcessPackage<(art::Level)4> > (art::Proce
ssPackage< (art::Level)4>::MyPrincipalé&, art::CurrentProcessingContext const*) () at /scratch/works
pace/art-release-build/SLF6/debug/build/art/v2_11_03/src/art/Framework/Principal/Worker.h:259

The failure occurs on event 5 when running our reconstruction:

lar —-c Reco.fcl -s /lariat/data/users/hsulliva/lariat_r6100_sr0004.root

History

#1 - 10/15/2018 10:25 AM - Kyle Knoepfel

- Status changed from New to Feedback

Hunter, can you please run valgrind on this process--this will help determine whether the bug is in ROOT, lariat, larsoft, or art.

setup valgrind v3_13_0

valgrind --leak-check=no --track-origins=yes —--log-file=valgrind.dump --suppressions=$RO0OTSYS/etc/valgrind-roo
t.supp lar -c <...>

Please post the valgrind.dump log file for us to look at.

#2 - 10/15/2018 12:11 PM - Hunter Sullivan

- File valgrind.dump added

| have attached the valgrind.dump log file after running:

valgrind --leak-check=no —--track-origins=yes --log-file=valgrind.dump —--suppressions=S$RO0OTSYS/etc/valgrind-roo
t.supp lar -c Reco.fcl -s /lariat/data/users/hsulliva/lariat_r6100_sr0004.root —-nskip 4

#3 - 10/19/2018 10:17 AM - Kyle Knoepfel
- Status changed from Feedback to Assigned
- Assignee set to Kyle Knoepfel

Thank you for the valgrind dump. The TrackMomentumCalculator class is fraught with design problems. | will do what | can to clean them up in a
short timescale.

#4 - 10/25/2018 01:46 PM - Kyle Knoepfel

- Status changed from Assigned to Resolved

- % Done changed from 0 to 100

This issue has been resolved with commits on the feature/knoepfel_TrackMomentumCalculator_cleanup branch in LArReco:
e larreco:52
e |arreco:f595673

e larreco:aba0a42

| have verified that the above commits result in a successful run of the job reported in this issue. A corresponding branch has been created in
https://cdcvs.fnal.gov/redmine/projects/larreco
https://cdcvs.fnal.gov/redmine/projects/larreco/repository/revisions/525a53c10783d8eb69c3e8f299195a31cf626d57
https://cdcvs.fnal.gov/redmine/projects/larreco/repository/revisions/f5956733c8568a586aabedbf25b72a27cdf5d1fc
https://cdcvs.fnal.gov/redmine/projects/larreco/repository/revisions/aba0a42a69a98b0c796f1be62802a5a3c1502cc0

lariatsoft:feature/knoepfel_TrackMomentumCalculator_cleanup that can be merged into the lariatsoft:develop branch once LArSoft has agreed to
adopt the changes, some of which break the current interface.

In brief, the TrackMomentumCalculator class has been drastically adjusted to support better data-access patterns and encapsulation of
implementation details. In particular, the following changes have been implemented:

Removal of the 'using namespace std;' directive that appeared in the header file (something that is never encouraged)
Removal of global variables that were declared (and defined!) in the header file (also something that is never encouraged)
Changing the public access of some data members and many member functions to private access

Removal of an unnecessary 2 MB of data members that were used only to translate to ROOT's interface

Removal of getchar() calls which cannot be used sensibly in a framework context

Although the TrackMomentumCalculator class can still be substantially polished, it is not clear whether that is warranted in light of other code that
needs to be addressed throughout LArSoft.

#5 - 10/25/2018 08:21 PM - Kyle Knoepfel
- Status changed from Resolved to Assigned

- % Done changed from 100 to 50

| was able to demonstrate a successful run with the prof build, but | have not been able to demonstrate a successful run with debug builds.

#6 - 10/26/2018 11:33 AM - Kyle Knoepfel
- Status changed from Assigned to Resolved

- % Done changed from 50 to 100

An additional commit was necessary to fix the problem at hand: invalid numbers (NaNs, etc.) were being presented to the minimization routine.
Whenever NaNs appear, the algorithm no longer takes them into account, thus avoiding the problem. If different behavior is desired, then an
additional discussion is necessary.

Implemented with commit larreco:21345fa on the same branches as before--although those branches have been rebased on top of the current
larreco:develop and lariatsoft:develop branches.

#7 - 10/29/2018 10:31 AM - Kyle Knoepfel

- Status changed from Resolved to Work in progress

#8 - 11/12/2018 11:27 AM - Kyle Knoepfel

- Status changed from Work in progress to Closed

Files

valgrind.dump 2.71 MB 10/15/2018 Hunter Sullivan
